
%	 Copyright (C) 2008  Frhwirth-Schnatter
%	 Copyright (C) 2011  Bluder, Plankensteiner
%
%    This program is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see <http://www.gnu.org/licenses/>.

% modified such that method can only handle regression
% models or MoE models based on univariate Gaussian data

if isfield(data,'censor') 
        mcmcout.Sperm = Sperm; 
end 
    if (m-mcmc.burnin)==1
        if size(data.y,1)==1
                if mix.df==0
                    mcmcout.par=struct('beta',zeros(mcmc.M,mix.d,mix.K),'sigma',zeros(mcmc.M,mix.K));
                else
                    mcmcout.par=struct('alpha',zeros(mcmc.M,mix.df),'beta',zeros(mcmc.M,mix.d-mix.df,mix.K),'sigma',zeros(mcmc.M,mix.K));
                end
        else  % multivariate mixture
           disp('Only implemented for univariate mixture model.'); return
        end
        if istorepost
            mcmcout.Nk=zeros(mcmc.M,mix.K);
            if size(data.y,1)==1
                    if mix.df==0
                        mcmcout.post.par=struct('beta',struct('b',zeros(mcmc.M,mix.d,mix.K),'B',zeros(mcmc.M,mix.d,mix.d,mix.K)),'sigma',struct('C',zeros(mcmc.M,mix.K),'c',zeros(mcmc.M,mix.K)));
                    else 
                        mcmcout.post.par=struct('alpha',struct('a',zeros(mcmc.M,mix.df),'A',zeros(mcmc.M,mix.df,mix.df)),'beta',struct('b',zeros(mcmc.M,mix.d-mix.df,mix.K),'B',zeros(mcmc.M,mix.d-mix.df,mix.d-mix.df,mix.K)),'sigma',struct('C',zeros(mcmc.M,mix.K),'c',zeros(mcmc.M,mix.K)));
                    end
            else  disp('Only implemented for univariate mixture model.'); return
            end
        end
    end
        mcmcout.par.beta(m-mcmc.burnin,:,:)=mix.par.beta;
        if mix.df>0  mcmcout.par.alpha(m-mcmc.burnin,:)=mix.par.alpha';end
        mcmcout.par.sigma(m-mcmc.burnin,:)=mix.par.sigma;
    if istorepost

                if mix.df==0
                        mcmcout.post.par.beta.b(m-mcmc.burnin,:,:)=post.par.beta.b;
                        mcmcout.post.par.beta.B(m-mcmc.burnin,:,:,:)=post.par.beta.B;
                else
                    mcmcout.post.par.beta.b(m-mcmc.burnin,:,:)=reshape(postreg.b(mix.df+1:end,1),(mix.d-mix.df),mix.K);
                    for k=1:mix.K;
                        ie=mix.df+(k-1)*(mix.d-mix.df)+[1:(mix.d-mix.df)];
                        mcmcout.post.par.beta.B(m-mcmc.burnin,:,:,k)=postreg.B(ie,ie);
                    end
                    mcmcout.post.par.alpha.a(m-mcmc.burnin,:)=postreg.b(1:mix.df,1)';
                    mcmcout.post.par.alpha.A(m-mcmc.burnin,:,:)=postreg.B(1:mix.df,1:mix.df);
                end

            if isfield(mcmcout.post.par,'sigma')
                if isfield(post.par,'sigma')
                    mcmcout.post.par.sigma.c(m-mcmc.burnin,:)=post.par.sigma.c;
                    mcmcout.post.par.sigma.C(m-mcmc.burnin,:)=post.par.sigma.C;
                end
            end
    end
    if ihier   % hierarchical prior
        if (m-mcmc.burnin)==1
            if size(data.y,1)==1
                mcmcout.hyper=zeros(mcmc.M,1);
            else
                mcmcout.hyper=zeros(mcmc.M,dr);
            end
        end
        if size(data.y,1)==1
            mcmcout.hyper(m-mcmc.burnin)=prior.par.sigma.C(1);
        else
            mcmcout.hyper(m-mcmc.burnin,:)=qincol(prior.par.sigma.C(:,:,1))';
        end
    end

if mix.K>1
    if ~mix.indicfix
        if mix.indicmod.dist(1:6)=='Multin'
            if (m-mcmc.burnin)==1
                if istorepost   mcmcout.post.weight=zeros(mcmc.M,mix.K);   end
                mcmcout.weight=zeros(mcmc.M,mix.K);
            end

            mcmcout.weight(m-mcmc.burnin,:)=mix.weight';
            mcmcout.Nk(m-mcmc.burnin,:)=post.weight(1,rho)-prior.weight(1,rho);
            if istorepost
                mcmcout.post.weight(m-mcmc.burnin,:)=post.weight;
            end
            
        % modified by O. Bluder Sept. 20, 2010
        elseif isfield(mix, 'MOE')
            if mix.indicmod.dist(1:6)=='FixedW'
                if (m-mcmc.burnin)==1
                    mcmcout.weight = mix.weight;
                end
                mcmcout.Nk(m-mcmc.burnin,:)=countex(S,mcmcout.model.K);
            else
                disp('mcmc for MOE with non-fixed weights not implemented yet')
                return;
            end
        % end modification
        else 
                disp('Function only implemented for MOE model.'); return
        end
    end
end

